-- Do not edit.  Generated by cheby 1.6.dev0 using these options:
--  -i svec_top_ffpg_map.cheby --gen-hdl svec_top_ffpg_map.vhd
-- Generated on Fri Feb 24 09:30:58 2023 by tlevens


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

entity svec_top_ffpg_map is
  port (
    rst_n_i              : in    std_logic;
    clk_i                : in    std_logic;
    wb_i                 : in    t_wishbone_slave_in;
    wb_o                 : out   t_wishbone_slave_out;

    -- a ROM containing the carrier metadata
    metadata_i           : in    t_wishbone_master_in;
    metadata_o           : out   t_wishbone_master_out;

    -- FFPG core 0
    ffpg0_i              : in    t_wishbone_master_in;
    ffpg0_o              : out   t_wishbone_master_out;

    -- FFPG core 1
    ffpg1_i              : in    t_wishbone_master_in;
    ffpg1_o              : out   t_wishbone_master_out
  );
end svec_top_ffpg_map;

architecture syn of svec_top_ffpg_map is
  signal adr_int                        : std_logic_vector(18 downto 2);
  signal rd_req_int                     : std_logic;
  signal wr_req_int                     : std_logic;
  signal rd_ack_int                     : std_logic;
  signal wr_ack_int                     : std_logic;
  signal wb_en                          : std_logic;
  signal ack_int                        : std_logic;
  signal wb_rip                         : std_logic;
  signal wb_wip                         : std_logic;
  signal metadata_re                    : std_logic;
  signal metadata_we                    : std_logic;
  signal metadata_wt                    : std_logic;
  signal metadata_rt                    : std_logic;
  signal metadata_tr                    : std_logic;
  signal metadata_wack                  : std_logic;
  signal metadata_rack                  : std_logic;
  signal ffpg0_re                       : std_logic;
  signal ffpg0_we                       : std_logic;
  signal ffpg0_wt                       : std_logic;
  signal ffpg0_rt                       : std_logic;
  signal ffpg0_tr                       : std_logic;
  signal ffpg0_wack                     : std_logic;
  signal ffpg0_rack                     : std_logic;
  signal ffpg1_re                       : std_logic;
  signal ffpg1_we                       : std_logic;
  signal ffpg1_wt                       : std_logic;
  signal ffpg1_rt                       : std_logic;
  signal ffpg1_tr                       : std_logic;
  signal ffpg1_wack                     : std_logic;
  signal ffpg1_rack                     : std_logic;
  signal rd_ack_d0                      : std_logic;
  signal rd_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_req_d0                      : std_logic;
  signal wr_adr_d0                      : std_logic_vector(18 downto 2);
  signal wr_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_sel_d0                      : std_logic_vector(3 downto 0);
begin

  -- WB decode signals
  adr_int <= wb_i.adr(18 downto 2);
  wb_en <= wb_i.cyc and wb_i.stb;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_rip <= '0';
      else
        wb_rip <= (wb_rip or (wb_en and not wb_i.we)) and not rd_ack_int;
      end if;
    end if;
  end process;
  rd_req_int <= (wb_en and not wb_i.we) and not wb_rip;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_wip <= '0';
      else
        wb_wip <= (wb_wip or (wb_en and wb_i.we)) and not wr_ack_int;
      end if;
    end if;
  end process;
  wr_req_int <= (wb_en and wb_i.we) and not wb_wip;

  ack_int <= rd_ack_int or wr_ack_int;
  wb_o.ack <= ack_int;
  wb_o.stall <= not ack_int and wb_en;
  wb_o.rty <= '0';
  wb_o.err <= '0';

  -- pipelining for wr-in+rd-out
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rd_ack_int <= '0';
        wr_req_d0 <= '0';
      else
        rd_ack_int <= rd_ack_d0;
        wb_o.dat <= rd_dat_d0;
        wr_req_d0 <= wr_req_int;
        wr_adr_d0 <= adr_int;
        wr_dat_d0 <= wb_i.dat;
        wr_sel_d0 <= wb_i.sel;
      end if;
    end if;
  end process;

  -- Interface metadata
  metadata_tr <= metadata_wt or metadata_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        metadata_rt <= '0';
        metadata_wt <= '0';
      else
        metadata_rt <= (metadata_rt or metadata_re) and not metadata_rack;
        metadata_wt <= (metadata_wt or metadata_we) and not metadata_wack;
      end if;
    end if;
  end process;
  metadata_o.cyc <= metadata_tr;
  metadata_o.stb <= metadata_tr;
  metadata_wack <= metadata_i.ack and metadata_wt;
  metadata_rack <= metadata_i.ack and metadata_rt;
  metadata_o.adr <= ((25 downto 0 => '0') & adr_int(5 downto 2)) & (1 downto 0 => '0');
  metadata_o.sel <= wr_sel_d0;
  metadata_o.we <= metadata_wt;
  metadata_o.dat <= wr_dat_d0;

  -- Interface ffpg0
  ffpg0_tr <= ffpg0_wt or ffpg0_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        ffpg0_rt <= '0';
        ffpg0_wt <= '0';
      else
        ffpg0_rt <= (ffpg0_rt or ffpg0_re) and not ffpg0_rack;
        ffpg0_wt <= (ffpg0_wt or ffpg0_we) and not ffpg0_wack;
      end if;
    end if;
  end process;
  ffpg0_o.cyc <= ffpg0_tr;
  ffpg0_o.stb <= ffpg0_tr;
  ffpg0_wack <= ffpg0_i.ack and ffpg0_wt;
  ffpg0_rack <= ffpg0_i.ack and ffpg0_rt;
  ffpg0_o.adr <= ((14 downto 0 => '0') & adr_int(16 downto 2)) & (1 downto 0 => '0');
  ffpg0_o.sel <= wr_sel_d0;
  ffpg0_o.we <= ffpg0_wt;
  ffpg0_o.dat <= wr_dat_d0;

  -- Interface ffpg1
  ffpg1_tr <= ffpg1_wt or ffpg1_rt;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        ffpg1_rt <= '0';
        ffpg1_wt <= '0';
      else
        ffpg1_rt <= (ffpg1_rt or ffpg1_re) and not ffpg1_rack;
        ffpg1_wt <= (ffpg1_wt or ffpg1_we) and not ffpg1_wack;
      end if;
    end if;
  end process;
  ffpg1_o.cyc <= ffpg1_tr;
  ffpg1_o.stb <= ffpg1_tr;
  ffpg1_wack <= ffpg1_i.ack and ffpg1_wt;
  ffpg1_rack <= ffpg1_i.ack and ffpg1_rt;
  ffpg1_o.adr <= ((14 downto 0 => '0') & adr_int(16 downto 2)) & (1 downto 0 => '0');
  ffpg1_o.sel <= wr_sel_d0;
  ffpg1_o.we <= ffpg1_wt;
  ffpg1_o.dat <= wr_dat_d0;

  -- Process for write requests.
  process (wr_adr_d0, wr_req_d0, metadata_wack, ffpg0_wack, ffpg1_wack) begin
    metadata_we <= '0';
    ffpg0_we <= '0';
    ffpg1_we <= '0';
    case wr_adr_d0(18 downto 17) is
    when "00" =>
      -- Submap metadata
      metadata_we <= wr_req_d0;
      wr_ack_int <= metadata_wack;
    when "01" =>
      -- Submap ffpg0
      ffpg0_we <= wr_req_d0;
      wr_ack_int <= ffpg0_wack;
    when "11" =>
      -- Submap ffpg1
      ffpg1_we <= wr_req_d0;
      wr_ack_int <= ffpg1_wack;
    when others =>
      wr_ack_int <= wr_req_d0;
    end case;
  end process;

  -- Process for read requests.
  process (adr_int, rd_req_int, metadata_i.dat, metadata_rack, ffpg0_i.dat,
           ffpg0_rack, ffpg1_i.dat, ffpg1_rack) begin
    -- By default ack read requests
    rd_dat_d0 <= (others => 'X');
    metadata_re <= '0';
    ffpg0_re <= '0';
    ffpg1_re <= '0';
    case adr_int(18 downto 17) is
    when "00" =>
      -- Submap metadata
      metadata_re <= rd_req_int;
      rd_dat_d0 <= metadata_i.dat;
      rd_ack_d0 <= metadata_rack;
    when "01" =>
      -- Submap ffpg0
      ffpg0_re <= rd_req_int;
      rd_dat_d0 <= ffpg0_i.dat;
      rd_ack_d0 <= ffpg0_rack;
    when "11" =>
      -- Submap ffpg1
      ffpg1_re <= rd_req_int;
      rd_dat_d0 <= ffpg1_i.dat;
      rd_ack_d0 <= ffpg1_rack;
    when others =>
      rd_ack_d0 <= rd_req_int;
    end case;
  end process;
end syn;
